=== debian/changelog ===
tippecanoe (2.45.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Anthony Fok <foka@debian.org>  Sat, 24 Feb 2024 21:13:57 -0700

tippecanoe (2.45.0-1) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Cleanup packaging.

  [ Anthony Fok ]
  * New upstream version 2.45.0
  * Link with -latomic on armel, mipsel, m68k, powerpc, and sh4.
    Fixes FTBFS on those architectures; see
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358
    Special thanks to Michael Tokarev for this workaround
    that he applied to debian/rules in the samba package.

 -- Anthony Fok <foka@debian.org>  Thu, 15 Feb 2024 23:30:17 -0700

tippecanoe (2.41.2-1) unstable; urgency=medium

  * Initial release (Closes: #1061548)

 -- Anthony Fok <foka@debian.org>  Fri, 26 Jan 2024 04:12:43 -0700
