## tippecanoe 2.49.0

=== debian/changelog ===
tippecanoe (2.49.0-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:25:31 +1100

tippecanoe (2.49.0-1) unstable; urgency=medium

  * New upstream version 2.49.0

 -- Anthony Fok <foka@debian.org>  Mon, 04 Mar 2024 13:09:17 -0700
