## tippecanoe 2.52.0

=== debian/changelog ===
tippecanoe (2.52.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Anthony Fok <foka@debian.org>  Sat, 23 Mar 2024 18:52:57 -0600

tippecanoe (2.52.0-1) unstable; urgency=medium

  * New upstream version 2.52.0

 -- Anthony Fok <foka@debian.org>  Fri, 22 Mar 2024 11:27:01 -0600

tippecanoe (2.49.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Anthony Fok <foka@debian.org>  Mon, 04 Mar 2024 13:35:57 -0700
