=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PREFIX := debian/tippecanoe/usr

ifneq (,$(filter armel mipsel m68k powerpc sh4,${DEB_HOST_ARCH}))
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358
# on these platforms g++ does not link with -latomic, resulting in
# errors such as:
#   /usr/bin/ld: geobuf.o: in function `std::__atomic_base<long long>::load(std::memory_order) const':
#   /usr/include/c++/13/bits/atomic_base.h:505:(.text+0x15e8): undefined reference to `__atomic_load_8'
# Special thanks to Michael Tokarev for this workaround, see:
# https://salsa.debian.org/samba-team/samba/-/blob/157711ffd09f56ae1cac8bd89fdc7e6b200ff7ad/debian/rules#L93-105
LDFLAGS += -latomic
endif

%:
	dh $@

override_dh_auto_test:
	-dh_auto_test
