=== debian/changelog ===
tippecanoe (2.53.0-1) unstable; urgency=medium

  * New upstream version 2.53.0

 -- Anthony Fok <foka@debian.org>  Thu, 11 Apr 2024 20:07:52 -0600
