=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: tippecanoe
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Anthony Fok <foka@debian.org>
 Section: science
 Priority: optional
